/*
ͻ
 NOM       : TERMINAL.C                                                      
 FONCTION  : Dmonstration de l'utilisation de STARCOMM.EXE (charg en DEVICE
           : DRIVER) grace aux procdures d'interface au C.                  
           : Permet un dialogue interractif directe entre 2 ordinateurs.     
           : Peut tre utilis comme mulateur simple de terminal TTY.       
 VERSION   : v2.0 (premire dition).                                        
 LANGAGE   : TURBO C version 1.0 et suivantes.                               
 SYNTAXE   : (path)> <path_pgm>CHEKLINK [<Format de comm>] [<options>]       
           :      <Format de comm> = [COMi:][vit][,par][,bit][,stp]          
           :      <options>        =                                         
           :        /T............... <T>erminal: cran d'un seul tenant.    
           :        /A............... <A>larme si erreur en rception.       
           :        /R ou /RALENTI... Emission ralentie des chaines          
           :                          (pour les sites distants lents).       
 REMARQUES : Par dfaut, ce sera la voie COM1 qui sera active par TERMINAL  
           : lors du lancement du programme. Si cette voie est inexistante,  
           : ou si la voie spcifie en "command-line" n'est pas reconnue,   
           : c'est la premire voie connue qui sera active. Si aucune voie  
           : n'est accessible, le programme s'interrompt immdiatement...    
 COPYRIGHT : HETRU Fabrice 1991-1994.                                        
ͼ
*/


/* ===== Headers, CONSTANTES et VARIABLES ===== */

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>

#include "STARINTF.C"


#define byte     unsigned char


#define Int1B     0x1B  /* N d'int. BIOS grant le "Ctrl-Break".           */
#define Int24     0x24  /* N d'int. grant les erreurs systme critiques.  */
#define SHVL      0x100 /* Spcificateur des touches spciales.             */
#define PARITE    1     /* Indicateur de slection pour la parit.          */
#define NBOCTETS  2     /* Indic. de slect. pour le nombre d'octets.       */
#define STOPBIT   3     /* Indic. de slect. pour le nombre de bits d'arrt.*/
#define T_Delay   10    /* Valeur du delai pour ralentir les missions.     */
#define EOS       0     /* Spcificateur de fin de chaine.                  */
#define FALSE     0     /* Valeur logique "FAUX".                           */
#define TRUE      1     /* Valeur logique "VRAI".                           */
#define StrLen    25    /* Taille maxi. retenue pour les chaines saisies.   */
#define MAXStrLen StrLen+1


/* Variables d'utilit gnrale. */
char     commande[127];
int      choix;
byte     n_car;
char     cr = 0x0D;
char     clrscreen = 0x0C;
byte     fin = FALSE;
byte     Saisie_Escape = FALSE;
byte     abandon = FALSE;
word     IO_err = FALSE;
/* Variables pour la gestion des ports sries. */
byte     ver[5] ;
byte     voie = '1';
byte     parity = 'N';
byte     longueur = '8';
byte     stop_bit = '1';
long     vitesse = 9600;
word     InBuffSz, OutBuffSz;
word     engorge_err = 0;
word     pari_err    = 0;
word     stop_err    = 0;
word     brkint      = 0;
word     erreur;
short    resul;
byte     OldRdTimMAX = 0;
byte     OldWrTimMAX = 0;
byte     RdTimMAX[2] = {2,0};
byte     WrTimMAX[2] = {2,0};
byte     TimOut[2]   = {'1',0};
div_t    result;
byte     Lent = FALSE;
char     echo = TRUE;
byte     LF_Used = TRUE;
byte     CR_Used = TRUE;
/* Variables pour la gestion de la vido. */
word     seg_ecran, off_ecran;
word     mode_scr, page_scr;
int      xh, yh;
char     dos_scr[80 * 25 * 2];
byte     terminal = FALSE;


/* ===== PROCEDURES D'ENTREES/SORTIES ===== */

/* Procdures INT pour contrler l'ordinateur local. */
/* ------------------------------------------------- */
void main_menu(); /* Utilise avant d'tre dfini dans le listing... */


void interrupt (*OldIError) ();


void interrupt IError()
  {
  int x0,y0;

  /* Mise  jour du tmoin d'erreur survenue. */
  IO_err = TRUE;  /* Est remis  FALSE avant ReadCOMM et WriteCOMM... */
  /* Traitement de remplacement It. DOS. */
  x0 = wherex(); y0 = wherey();
  window(1,1,80,25);
  gotoxy(1,25);
  textbackground(WHITE);
  textcolor(LIGHTRED);
  clreol();
  gotoxy(21,25);
  switch(_DI)
    {
    case 0x0A: cputs("Time-out en criture"); break;
    case 0x0B: cputs(" Erreur en lecture");
    }
  cputs(" sur le port srie");
  delay(1000);
  main_menu();
  textbackground(BLUE);
  if (! terminal)
    {
    if (y0<14) window(1,4,80,13);
      else window(1,15,80,24);
    }
  else window(1,3,80,24);
  gotoxy(x0,y0);
  /* "interrupt" de l'en-tte IError provoque des PUSH: on les vide... */
  asm mov sp,bp
  asm pop bp
  asm pop di
  asm pop si
  asm pop ds
  asm pop es
  asm pop dx
  asm pop cx
  asm pop bx
  asm pop ax
  /* Prparation du retour  l'application sans transiter par le DOS. */
  asm pop ax /* Dpilage du IRET associ au "system call"... */
  asm pop ax /* CS:IP et Flags. */
  asm pop ax
  asm pop ax /* Restitution de l'environnement CPU. */
  asm pop bx
  asm pop cx
  asm pop dx
  asm pop si
  asm pop di
  asm pop bp
  asm pop ds
  asm pop es
  enable();  /* STI puis IRET... */
  asm iret
  /* En code assembleur post-compil, suivent les POP gnrs par TCC:
     on n'y accde jamais !... (vids de la pile par nous plus tt). */
  }


void interrupt (*OldIBreak) ();


void interrupt CtrlBreak()
  {
  abandon = TRUE;
  }


/* Procdures de gestion de la console locale. */
/* ------------------------------------------- */
int kb_hit()
  {
  inregs.h.ah = 1;
  int86(0x16,&inregs,&outregs);
  return( !(outregs.x.flags & 64) );
  }


int get_clav()
  {
  int h,l;

  if (kb_hit())
    {
    inregs.h.ah = 0;
    int86(0x16,&inregs,&outregs);
    l = outregs.h.al;
    h = outregs.h.ah;
    if (l==0) l = h+SHVL;
    if (l==3) abandon = TRUE;
    return(l);
    }
  else return(0);
  }


void scroll_down()
  {
  char scroll[3];

  scroll[1] = 0x0A;
  scroll[2] = 0x0D;
  scroll[3] = EOS;
  cputs(&scroll[1]);
  }


void blanchi(int x, int y, int l)
  {
  byte col;

  gotoxy(x,y);
  for (col=x; col<=x+l-1; col++) cputs(" ");
  gotoxy(x,y);
  }


void delete(char *ch,int pos,unsigned char Nb)
  {
  pos--;
  while ( (pos+Nb<=MAXStrLen) & (*(ch+pos)!=EOS) )
    {
    *(ch+pos) = *(ch+pos+Nb);
    pos++;
    }
  }


void Insert(char car,char *Chaine,int pos)
  {
  int i,j;

  if (pos<1) pos = 1;
  i = 0;
  while ( (*(Chaine+i)!=0) & (i<strlen(Chaine)) ) i++;
  if (i<StrLen)
    {
    i++;
    for (j=i;j>=pos;j--) *(Chaine+j) = *(Chaine+j-1);
    *(Chaine+j) = car;
    }
  }


void back(char *ch,int x,int l)
  {
  int k,x2;

  k = 0;
  x2 = wherex();
  if (x==x2) k=1;
  delete(ch,x2-x+k,1);
  blanchi(x,wherey(),l);
  cputs(ch);
  gotoxy(x2+k-1,wherey());
  }


void vid(char *ch,int x,int y,int l)
  {
  blanchi(x,y,l);
  strcpy(ch,"");
  }


void ReadCar(char *Car_lu,byte *Fonct_Touche)
/* Lit un caractre et en retourne le code de la lettre majuscule associe.  */
/* 'Esc' implique la fin de la saisie.                                       */
/* Ne retient que le second code des touches qui gnrent 2 codes.           */
  {
  int loc_car;

  Saisie_Escape = FALSE;
  *Fonct_Touche = FALSE;
  loc_car = 0;
  *Car_lu = ' ';
  while (!kb_hit());
  if ( (loc_car=get_clav())>=SHVL )
    {
    *Fonct_Touche = TRUE;
    *Car_lu = loc_car - SHVL;
    }
  else *Car_lu = toupper((char)loc_car);
  if (*Car_lu==0x1B) Saisie_Escape = TRUE;
  }


void Lit_chaine(char *chaine,int x,int y,int l)
/* Lit une chaine de l caractres en (x,y), en att. courant sur fond noir.   */
/* Restitue un fond BLUE en fin de saisie.                                   */
/* 'Esc' implique l'interruption de la saisie,                               */
/* avec la non modification de la variable 'chaine' de l'appelant.           */
/* La fin normale de la saisie est reconnue par le code 'RC'.                */
/* Les touches de codes doubles sont ignores.                               */
  {
  char LocalChaine[MAXStrLen];
  char carac;
  byte Fonct_Touche;
  int oldx;

  textbackground(BLACK);
  if (*chaine!=0)
    {
    strcpy(LocalChaine,chaine);
    blanchi(x,y,l);
    cputs(LocalChaine);
    }
  else vid(LocalChaine,x,y,l);
  do
    {
    ReadCar(&carac,&Fonct_Touche);
    if (!Fonct_Touche)
      {
      if (carac==0x08)
        {
        if (strlen(LocalChaine)<l) back(LocalChaine,x,l);
          else
            {
            delete(LocalChaine,wherex()-x+1,1);
            blanchi(x,wherey(),l);
            cputs(LocalChaine);
            }
        }
      else
        {
        if ( (!Saisie_Escape) & (strlen(LocalChaine)<l) & (carac!=0x0D) )
          {
          Insert(carac,LocalChaine,wherex()-x+1);
          oldx = wherex();
          blanchi(x,y,l);
          cputs(LocalChaine);
          if (strlen(LocalChaine)<l) gotoxy(oldx+1,y);
            else gotoxy(x+l-1,y);
          }
        }
      }
    else
      {
      switch (carac)
        {
        case 0x47: /* Home */
          gotoxy(x,y);
          break;
        case 0x4F: /* End */
          if (strlen(LocalChaine)<l) gotoxy(x+strlen(LocalChaine),y);
            else gotoxy(x+l-1,y);
          break;
        case 0x4B: /* Left Arrow */
          if (wherex()>x) gotoxy(wherex()-1,y);
          break;
        case 0x4D: /* Right Arrow */
          if (wherex()<x+strlen(LocalChaine))
            {
            if (wherex()<x+l-1) gotoxy(wherex()+1,y);
              else gotoxy(x+l-1,y);
            }
          break;
        case 0x53: /* Del */
          delete(LocalChaine,wherex()-x+1,1);
          oldx = wherex();
          blanchi(x,y,l);
          cputs(LocalChaine);
          gotoxy(oldx,y);
        }
      }
    }
  while ( (carac!=0x0D) & (!Saisie_Escape) & (!abandon) );
  textbackground(BLUE);
  oldx = wherex();
  blanchi(x,y,l);
  if ( !(Saisie_Escape|abandon) )
    {
    cputs(LocalChaine);
    gotoxy(oldx,y);
    }
  else gotoxy(x,y);
  if ( (carac==0x0D) & (LocalChaine!="") ) strcpy(chaine,LocalChaine);
  scroll_down();
  }


void stock_commande_format()
  /* Mise  jour des spcificateurs de format. */
  {
  /* Port srie  utiliser. */
  if (strcmp(commande,"COM1:")==0) voie = '1';
  if (strcmp(commande,"COM2:")==0) voie = '2';
  if (strcmp(commande,"COM3:")==0) voie = '3';
  if (strcmp(commande,"COM4:")==0) voie = '4';
  /* Vitesse. */
  if (strcmp(commande,"110")==0) vitesse = 110;
  if (strcmp(commande,"150")==0) vitesse = 150;
  if (strcmp(commande,"300")==0) vitesse = 300;
  if (strcmp(commande,"600")==0) vitesse = 600;
  if (strcmp(commande,"1200")==0) vitesse = 1200;
  if (strcmp(commande,"2400")==0) vitesse = 2400;
  if (strcmp(commande,"4800")==0) vitesse = 4800;
  if (strcmp(commande,"9600")==0) vitesse = 9600;
  if (strcmp(commande,"19200")==0) vitesse = 19200;
  if (strcmp(commande,"28800")==0) vitesse = 28800;
  if (strcmp(commande,"38400")==0) vitesse = 38400;
  if (strcmp(commande,"57600")==0) vitesse = 57600;
  if (strcmp(commande,"115200")==0) vitesse = 115200;
  /* Parit. */
  if (strcmp(commande,"N")==0) parity = 'N';
  if (strcmp(commande,"I")==0) parity = 'I';
  if (strcmp(commande,"P")==0) parity = 'P';
  if (strcmp(commande,"T")==0) parity = 'T';
  if (strcmp(commande,"R")==0) parity = 'R';
  /* Nombre de bits. */
  if (strcmp(commande,"5")==0) longueur = '5';
  if (strcmp(commande,"6")==0) longueur = '6';
  if (strcmp(commande,"7")==0) longueur = '7';
  if (strcmp(commande,"8")==0) longueur = '8';
  /* Bit d'arrt. */
  if (strcmp(commande,"1")==0) stop_bit = '1';
  if (strcmp(commande,"2")==0) stop_bit = '2';
  }


void setup_ecran_inprog()
  /* Dtermine mode/page cran, en sauvegarde le texte, l'init. Text/80x25/0.*/
  {
  inregs.h.ah = 0x0F;
  int86(0x10,&inregs,&outregs);
  mode_scr = outregs.h.al;
  page_scr = outregs.h.bh;
  if ( (mode_scr==0) | (mode_scr==1) | (mode_scr==2)
       | (mode_scr==3) | (mode_scr==7) )
    {
    xh = wherex();
    yh = wherey();
    if (mode_scr==7) seg_ecran = 0xB000;
      else seg_ecran = 0xB800;
    switch (mode_scr)
      {
      case 0:
      case 1: off_ecran = 40 * 25 * page_scr;
              break;
      case 2:
      case 3:
      case 7: off_ecran = 80 * 25 * page_scr;
      }
    movedata(seg_ecran,off_ecran,FP_SEG(&dos_scr[0]),FP_OFF(&dos_scr[0]),80*25*2);
    }
  if (mode_scr==7) textmode(7);
    else textmode(3);
  inregs.h.al = 0;
  inregs.h.ah = 5;
  int86(0x10,&inregs,&outregs);
  }


void setup_ecran_outprog()
  /* Restitue l'cran initial s'il n'tait pas de type graphique...          */
  {
  inregs.h.al = mode_scr;
  inregs.h.ah = 0;
  int86(0x10,&inregs,&outregs);
  inregs.h.al = page_scr;
  inregs.h.ah = 5;
  int86(0x10,&inregs,&outregs);
  if ( (mode_scr==0) | (mode_scr==1) | (mode_scr==2)
       | (mode_scr==3) | (mode_scr==7) )
    {
    movedata(FP_SEG(&dos_scr[0]),FP_OFF(&dos_scr[0]),seg_ecran,off_ecran,80*25*2);
    gotoxy(xh,yh);
    }
  else clrscr();
  }


/* ===== PROCEDURES DE GESTION DES POP-UP ET DU MENU  ===== */

/* Procdure d'affichage CopyRight/Aide ou d'Infos. */
/* ------------------------------------------------ */
void informations(byte num_page)
  {
  int  offscr, xinit, yinit;
  char bscr[80 * 15 * 2];
  char help[47 * 15] =
               "TERMINAL.COM(C)opyRight HETRU 1994Ŀ "
               "Programme de dmonstration pour STARCOMM.EXE "
               "------ Pilote rsident de version      ----- "
               "F1...Aide; F2...Infos/SetUp; F3...Cmde modem "
               "Commandes dans la fentre de SetUp (F2):     "
               " Tab,BackSpace ---> slection dlai time-out "
               " Flches Up/Dn/Lft/Rgt ---> ACTIF|INACTIF.   "
               "Alt-P...permet de dfinir le format de comm. "
               " port......: N de COM:  utiliser (1  4),  "
               " vitesse...: entre 110 et 115200 bits/sec.,  "
               " structure.: <Parit>,<Nb_bits>,<Stop_bits>  "
               "Alt-F.....emet une phrase de test dj prte "
               "Alt-C...........efface le contenu de l'cran "
               "Alt-Q, Ctrl-Break ou Ctrl-C....pour terminer "
               "Pressez une touche";
  char infos[47 * 15] =
               "Ŀ "
               "   DSR:      CTS:      RI:      DCD:        "
               "  Comptabilit des erreurs survenues:       "
               "       engorgement...        occurence(s)    "
               "       parit........        occurence(s)    "
               "       bit d'arrt...        occurence(s)    "
               "       break_int.....        occurence(s)    "
               "  TimeOut rcept..  1 2 3 4 5 6 7 8 9 sec. "
               "   TimeOut mission  1 2 3 4 5 6 7 8 9 sec. "
               "  Hand-shake matriel.............          "
               "   Hand-shake Xon(' ')/Xoff(' ')...          "
               "  Echo local......................          "
               "   (1)LF:LFeed (2)CR:LFeed (3)LF|CR:LFeed   "
               "                                             "
               "'ESC' pour sortir";
  byte Init_aff;
  byte H_Shk   ;
  byte *SendOK = 0;
  byte *NbXoff = 0;
  char code[2] = {' ',EOS};
  static byte StatusTOChg = 1;

  Init_aff = TRUE;
  choix = ' ';
  xinit = wherex(); yinit = wherey();
  offscr = 5 * 80 * 2;
  movedata(seg_ecran,offscr,FP_SEG(&bscr[0]),FP_OFF(&bscr[0]),80*15*2);
  window(18,6,64,20);
  textbackground(WHITE);
  textcolor(BLACK);
  clrscr();
  gotoxy(1,1);
  switch(num_page)
    {
    case 1:
      {
      cputs(help);
      gotoxy(36,3);
      cputs(ver);
      gotoxy(15,15);
      textbackground(BLACK);
      textcolor(WHITE);
      delay(150);
      cputs("Pressez une touche");
      while (get_clav()==0);
      break;
      }
    case 2:
      {
      cputs(infos);
      textbackground(BLUE);
      textcolor(CYAN);
      gotoxy(2,14);
      cputs("Tab,BackSpace  Flche-Up/Dn/Lft/Rgt  1  3");
      textbackground(WHITE);
      textcolor(BLACK);
      gotoxy(38,10);
      if ( (HandShake_Status(RTS_CTS,SendOK)==Inactif) &
      (HandShake_Status(DTR_DSR,SendOK)==Inactif) ) cputs(" Aucun ");
      if (HandShake_Status(RTS_CTS,SendOK)!=Inactif) cputs("RTS/CTS");
      if (HandShake_Status(DTR_DSR,SendOK)!=Inactif) cputs("DTR/DSR");
      gotoxy(38,11);
      if (XonoffShaking_Status(SendOK,NbXoff)!=Inactif) cputs(" ACTIF ");
        else cputs("INACTIF");
      gotoxy(38,12);
      if (echo) cputs(" ACTIF ");
        else cputs("INACTIF");
      code[0] = (char)Xon;
      gotoxy(21,11);cputs(code);
      code[0] = (char)Xoff;
      gotoxy(31,11);cputs(code);
      gotoxy(15,15);
      textbackground(BLACK);
      textcolor(WHITE);
      delay(150);
      cputs("'ESC' pour sortir ");
      gotoxy(25,4); cputs("     ");
      gotoxy(25,5); cputs("     ");
      gotoxy(25,6); cputs("     ");
      gotoxy(25,7); cputs("     ");
      RdTimMAX[0] = 0;
      WrTimMAX[0] = 0;
      ResetCOM_and_TimMAX(RdTimMAX[0],&OldRdTimMAX,WrTimMAX[0],&OldWrTimMAX);
      RdTimMAX[0] = OldRdTimMAX;
      WrTimMAX[0] = OldWrTimMAX;
      switch (RdTimMAX[0])
        {
        case 1:
          {
          gotoxy(22,8);
          cputs("");
          break;
          }
        default:
          {
          gotoxy(22+RdTimMAX[0],8);
          result = div(RdTimMAX[0],2);
          TimOut[0] = result.quot + 0x30;
          cputs(&TimOut[0]);
          }
        }
      switch (WrTimMAX[0])
        {
        case 1:
          {
          gotoxy(22,9);
          cputs("");
          break;
          }
        default:
          {
          gotoxy(22+WrTimMAX[0],9);
          result = div(WrTimMAX[0],2);
          TimOut[0] = result.quot + 0x30;
          cputs(&TimOut[0]);
          }
        }
      if (LF_Used & CR_Used)
        {
        gotoxy(30,13);
        cputs("(3)");
        }
      else
        {
        if (LF_Used)
          {
          gotoxy(6,13);
          cputs("(1)");
          }
        if (CR_Used)
          {
          gotoxy(18,13);
          cputs("(2)");
          }
        }
      switch (StatusTOChg)
        {
        case 1:
          {
          gotoxy(38,10);
          if ( (HandShake_Status(RTS_CTS,SendOK)==Inactif) &
          (HandShake_Status(DTR_DSR,SendOK)==Inactif) ) cputs(" Aucun ");
          if (HandShake_Status(RTS_CTS,SendOK)!=Inactif) cputs("RTS/CTS");
          if (HandShake_Status(DTR_DSR,SendOK)!=Inactif) cputs("DTR/DSR");
          break;
          }
        case 2:
          {
          gotoxy(38,11);
          if (XonoffShaking_Status(SendOK,NbXoff)!=Inactif) cputs(" ACTIF ");
            else cputs("INACTIF");
          break;
          }
        case 3:
          {
          gotoxy(38,12);
          if (echo) cputs(" ACTIF ");
            else cputs("INACTIF");
          }
        }
      while ( (choix!=0x1B) & (!abandon) )
        {
        if ( (etat_du_modem()) | Init_aff )
          {
          gotoxy(10,2);
          if (Pret) cputs("OUI");
            else
              {
              if (dDSR) { cputs("OUI"); delay(10); gotoxy(10,2); }
              cputs("Non");
              }
          gotoxy(20,2);
          if (Clear_to_send) cputs("OUI");
            else
              {
              if (dCTS) { cputs("OUI"); delay(10); gotoxy(20,2); }
              cputs("Non");
              }
          gotoxy(29,2);
          if (Sonnerie) cputs("OUI");
            else
              {
              if (dRI) { cputs("OUI"); delay(10); gotoxy(29,2); }
              cputs("Non");
              }
          gotoxy(39,2);
          if (Porteuse) cputs("OUI");
            else
              {
              if (dDCD) { cputs("OUI"); delay(10); gotoxy(39,2); }
              cputs("Non");
              }
          gotoxy(33,15);
          }
        if ( (Errors_Report()) | Init_aff )
          {
          engorge_err = engorge_err + Engorgement;
          pari_err = pari_err + Parite;
          stop_err = stop_err + Stop_bit;
          brkint = brkint + Break_it;
          gotoxy(25,4); printf("%5u",engorge_err);
          gotoxy(25,5); printf("%5u",pari_err);
          gotoxy(25,6); printf("%5u",stop_err);
          gotoxy(25,7); printf("%5u",brkint);
          gotoxy(33,15);
          }
        Init_aff = FALSE;
        if ( (choix=get_clav()) != 0 )
          {
          if (choix==0x08) /* BackSpace: Rglage du time-out en rception... */
            {
            if (RdTimMAX[0]==1) RdTimMAX[0]++;
              else RdTimMAX[0] = RdTimMAX[0] + 2;
            if (RdTimMAX[0]>18) RdTimMAX[0]=1;
            ResetCOM_and_TimMAX(RdTimMAX[0],&OldRdTimMAX,
              WrTimMAX[0],&OldWrTimMAX);
            textbackground(WHITE);
            textcolor(BLACK);
            gotoxy(22,8);
            cputs(" 1 2 3 4 5 6 7 8 9");
            textbackground(BLACK);
            textcolor(WHITE);
            switch (RdTimMAX[0])
              {
              case 1:
                {
                gotoxy(22,8);
                cputs("");
                break;
                }
              default:
                {
                gotoxy(22+RdTimMAX[0],8);
                result = div(RdTimMAX[0],2);
                TimOut[0] = result.quot + 0x30;
                cputs(&TimOut[0]);
                }
              }
            }
          if (choix==0x09) /* Tab: Rglage du time-out en mission... */
            {
            if (WrTimMAX[0]==1) WrTimMAX[0]++;
              else WrTimMAX[0] = WrTimMAX[0] + 2;
            if (WrTimMAX[0]>18) WrTimMAX[0]=1;
            ResetCOM_and_TimMAX(RdTimMAX[0],&OldRdTimMAX,
              WrTimMAX[0],&OldWrTimMAX);
            textbackground(WHITE);
            textcolor(BLACK);
            gotoxy(22,9);
            cputs(" 1 2 3 4 5 6 7 8 9");
            textbackground(BLACK);
            textcolor(WHITE);
            switch (WrTimMAX[0])
              {
              case 1:
                {
                gotoxy(22,9);
                cputs("");
                break;
                }
              default:
                {
                gotoxy(22+WrTimMAX[0],9);
                result = div(WrTimMAX[0],2);
                TimOut[0] = result.quot + 0x30;
                cputs(&TimOut[0]);
                }
              }
            }
          if ( (choix>='1') & (choix<='3') )
            {
            textbackground(WHITE);
            textcolor(BLACK);
            gotoxy(6,13);
            cputs("(1)");
            gotoxy(18,13);
            cputs("(2)");
            gotoxy(30,13);
            cputs("(3)");
            textbackground(BLACK);
            textcolor(WHITE);
            switch (choix)
              {
              case '1': {
                 gotoxy(6,13);
                 cputs("(1)");
                 LF_Used = TRUE;
                 CR_Used = FALSE;
                 break;
                 }
              case '2': {
                 gotoxy(18,13);
                 cputs("(2)");
                 LF_Used = FALSE;
                 CR_Used = TRUE;
                 break;
                 }
              case '3': {
                 gotoxy(30,13);
                 cputs("(3)");
                 LF_Used = TRUE;
                 CR_Used = TRUE;
                 }
              }
            }
          if ( (choix==0x148) | (choix==0x150) ) /* Flche haut ou bas */
            {
            if (choix==0x148) StatusTOChg--;
              else StatusTOChg++;
            if (StatusTOChg>3) StatusTOChg=1;
            if (StatusTOChg<1) StatusTOChg=3;
            textbackground(WHITE);
            textcolor(BLACK);
            gotoxy(38,10);
            if ( (HandShake_Status(RTS_CTS,SendOK)==Inactif) &
            (HandShake_Status(DTR_DSR,SendOK)==Inactif) ) cputs(" Aucun ");
            if (HandShake_Status(RTS_CTS,SendOK)!=Inactif) cputs("RTS/CTS");
            if (HandShake_Status(DTR_DSR,SendOK)!=Inactif) cputs("DTR/DSR");
            gotoxy(38,11);
            if (XonoffShaking_Status(SendOK,NbXoff)!=Inactif) cputs(" ACTIF ");
              else cputs("INACTIF");
            gotoxy(38,12);
            if (echo) cputs(" ACTIF ");
              else cputs("INACTIF");
            textbackground(BLACK);
            textcolor(WHITE);
            switch (StatusTOChg)
              {
              case 1:
                {
                gotoxy(38,10);
                if ( (HandShake_Status(RTS_CTS,SendOK)==Inactif) &
                (HandShake_Status(DTR_DSR,SendOK)==Inactif) ) cputs(" Aucun ");
                if(HandShake_Status(RTS_CTS,SendOK)!=Inactif) cputs("RTS/CTS");
                if(HandShake_Status(DTR_DSR,SendOK)!=Inactif) cputs("DTR/DSR");
                break;
                }
              case 2:
                {
                gotoxy(38,11);
                if (XonoffShaking_Status(SendOK,NbXoff)!=Inactif)
                  cputs(" ACTIF ");
                else cputs("INACTIF");
                break;
                }
              case 3:
                {
                gotoxy(38,12);
                if (echo) cputs(" ACTIF ");
                  else cputs("INACTIF");
                }
              }
            }
          if ( (choix==0x14B) | (choix==0x14D) ) /* Flche droite ou gauche */
            {
            switch (StatusTOChg)
              {
              case 1:
                {
                gotoxy(38,10);
                if (choix==0x14D)
                  {
                  if (HandShake_Status(RTS_CTS,SendOK)!=Inactif)
                    {
                    HandShake_Setup(RTS_CTS,FALSE);
                    HandShake_Setup(DTR_DSR,Bilateral);
                    textbackground(WHITE);
                    textcolor(BLACK);
                    cputs("RTS/CTS");
                    textbackground(BLACK);
                    textcolor(WHITE);
                    gotoxy(38,10);
                    cputs("DTR/DSR");
                    }
                  else
                    {
                    if (HandShake_Status(DTR_DSR,SendOK)!=Inactif)
                      {
                      HandShake_Setup(DTR_DSR,FALSE);
                      textbackground(WHITE);
                      textcolor(BLACK);
                      cputs("DTR/DSR");
                      textbackground(BLACK);
                      textcolor(WHITE);
                      gotoxy(38,10);
                      cputs(" Aucun ");
                      }
                    else
                      {
                      if ( (HandShake_Status(RTS_CTS,SendOK)==Inactif) &
                      (HandShake_Status(DTR_DSR,SendOK)==Inactif) )
                        {
                        HandShake_Setup(RTS_CTS,Bilateral);
                        textbackground(WHITE);
                        textcolor(BLACK);
                        cputs(" Aucun ");
                        textbackground(BLACK);
                        textcolor(WHITE);
                        gotoxy(38,10);
                        cputs("RTS/CTS");
                        }
                      }
                    }
                  }
                else
                  {
                  if (HandShake_Status(RTS_CTS,SendOK)!=Inactif)
                    {
                    HandShake_Setup(RTS_CTS,FALSE);
                    textbackground(WHITE);
                    textcolor(BLACK);
                    cputs("RTS/CTS");
                    textbackground(BLACK);
                    textcolor(WHITE);
                    gotoxy(38,10);
                    cputs(" Aucun ");
                    }
                  else
                    {
                    if (HandShake_Status(DTR_DSR,SendOK)!=Inactif)
                      {
                      HandShake_Setup(DTR_DSR,FALSE);
                      HandShake_Setup(RTS_CTS,Bilateral);
                      textbackground(WHITE);
                      textcolor(BLACK);
                      cputs("DTR/DSR");
                      textbackground(BLACK);
                      textcolor(WHITE);
                      gotoxy(38,10);
                      cputs("RTS/CTS");
                      }
                    else
                      {
                      if ( (HandShake_Status(RTS_CTS,SendOK)==Inactif) &
                      (HandShake_Status(DTR_DSR,SendOK)==Inactif) )
                        {
                        HandShake_Setup(DTR_DSR,Bilateral);
                        textbackground(WHITE);
                        textcolor(BLACK);
                        cputs(" Aucun ");
                        textbackground(BLACK);
                        textcolor(WHITE);
                        gotoxy(38,10);
                        cputs("DTR/DSR");
                        }
                      }
                    }
                  }
                break;
                }
              case 2:
                {
                gotoxy(38,11);
                if (XonoffShaking_Status(SendOK,NbXoff)!=Inactif)
                  {
                  XonoffShaking_Setup(FALSE);
                  cputs("INACTIF");
                  }
                else
                  {
                  XonoffShaking_Setup(Bilateral);
                  cputs(" ACTIF ");
                  }
                break;
                }
              case 3:
                {
                echo = ! echo;
                gotoxy(38,12);
                if (echo) cputs(" ACTIF ");
                  else cputs("INACTIF");
                }
              }
            } /* End_if */
          } /* End_if */
        gotoxy(33,15);
        } /* End_while */
      choix = ' ';
      } /* End_case_2 */
    } /* End_switch */
  textbackground(BLUE);
  textcolor(WHITE);
  clrscr();
  if (! terminal)
    {
    if (yinit<14) window(1,4,80,13);
      else window(1,15,80,24);
    }
  else window(1,3,80,24);
  movedata(FP_SEG(&bscr[0]),FP_OFF(&bscr[0]),seg_ecran,offscr,80*15*2);
  gotoxy(xinit,yinit);
  }


/* Procdures utilitaires. */
/* ----------------------- */
void main_menu()
  {
  textbackground(LIGHTGRAY);
  textcolor(BLACK);
  gotoxy(1,25);clreol();
  gotoxy(2,25);
  cputs(" Alt-Q Quitter   Alt-P Paramtres   Alt-F Fox...message de test  Alt-C ClrScr");
  textcolor(RED);
  gotoxy(3,25);cputs("Alt-Q");
  gotoxy(19,25);cputs("Alt-P");
  gotoxy(38,25);cputs("Alt-F");
  gotoxy(67,25);cputs("Alt-C");
  }


void page_de_fond()
  {
  /* Fond de la prsentation */
  textbackground(BLUE);
  clrscr();
  textbackground(WHITE);
  clreol();
  textbackground(LIGHTGRAY);
  gotoxy(1,25);
  clreol();
  textcolor(MAGENTA);
  gotoxy(1,1); clreol();
  cputs(" PROGRAMME DE TEST DE LA LIAISON ASYNCHRONE GEREE PAR STARCOMM.EXE");
  cputs(" version ");cputs(ver);
  if (! terminal)
    {
    gotoxy(1,3); cputs("");
    cputs("Emission");
    cputs("");
    gotoxy(1,14); cputs("");
    cputs("Rception");
    cputs("");
    }
  /* Menu du bas de page */
  main_menu();
  /* Paramtres de haut de page. */
  textbackground(BLACK);
  textcolor(LIGHTGRAY);
  gotoxy(1,2);
  cputs(" Port:        Vitesse:             Structure: parit    ,    bits,    stop-bit");
  textbackground(LIGHTGRAY);
  textcolor(BLACK);
  gotoxy(9,2); cputs("   ");
  gotoxy(9,2); printf(" %c ",voie);
  gotoxy(27,2);
  switch (vitesse)
    {
    case  110: cputs("   110  ");
               break;
    case  150: cputs("   150  ");
               break;
    case  300: cputs("   300  ");
               break;
    case  600: cputs("   600  ");
               break;
    case 1200: cputs("  1200  ");
               break;
    case 2400: cputs("  2400  ");
               break;
    case 4800: cputs("  4800  ");
               break;
    case 9600: cputs("  9600  ");
               break;
    case 19200: cputs("  19200 ");
                break;
    case 28800: cputs("  28800 ");
                break;
    case 38400: cputs("  38400 ");
                break;
    case 57600: cputs("  57600 ");
                break;
    case 115200: cputs(" 115200 ");
    }
  gotoxy(56,2); cputs("   ");
  gotoxy(60,2); cputs("   ");
  gotoxy(69,2); cputs("   ");
  gotoxy(57,2); printf("%c",parity);
  gotoxy(61,2); printf("%c",longueur);
  gotoxy(70,2); printf("%c",stop_bit);
  /* Mise en tat des paramtres vido pour la suite du programme. */
  textbackground(BLUE);
  if (terminal) window(1,3,80,24);
    else window(1,4,80,13);
  gotoxy(1,1);
  }


void set_up_menu()
  {
  textbackground(LIGHTGRAY);
  textcolor(BLACK);
  gotoxy(2,25);clreol();
  gotoxy(2,25);
  cputs("  Port srie       Vitesse de la communication       Structure       Esc-FIN ");
  textcolor(RED);
  gotoxy(4,25);cputs("P");
  gotoxy(21,25);cputs("V");
  gotoxy(55,25);cputs("S");
  gotoxy(71,25);cputs("Esc");
  }


Port_serie()
  {
  byte previous_voie;

  choix = 0;
  /* Sous-menu du bas de page. */
  textbackground(LIGHTGRAY);
  textcolor(BLACK);
  gotoxy(1,25);clreol();
  gotoxy(1,25);
  cputs(" Slection du port de communication:      OU              puis");
  textcolor(RED);
  gotoxy(38,25); cputs("1");
  gotoxy(42,25); cputs("4");
  gotoxy(48,25); cputs("  ou  ");
  gotoxy(50,25); printf("%c",16);
  gotoxy(55,25); printf("%c",17);
  gotoxy(65,25); cputs("Retour chariot");
  textcolor(BLACK);
  gotoxy(10,2);
  /* Choix */
  while ( (choix!=0x0D) & (!abandon) )
    {
    while ( (choix=get_clav()) == 0 );
    switch (choix)
      {
      case '1':
      case '2':
      case '3':
      case '4':
        {
        previous_voie = voie;
        voie = choix;
        printf("%c",voie);
        delay(200);
        gotoxy(10,2);
        if (!ComExist[voie-0x31]) resul=1; else resul=0;
        if (resul!=0)
          {
          voie = previous_voie;
          printf("%c%c",voie,0x07);
          gotoxy(10,2);
          }
        else
          {
          erreur = Close_Port();
          CommPort = voie-0x31;
          erreur = Open_Port();
          Voie_active = voie;
          IOStream_WRITE(0,0,0);  /* Assure l'orientation du DEVICE...     */
          IOStream_WRITE(0,0,0);  /* Assure reset des contrles de flux... */
          resul = Init_Port(longueur,stop_bit,parity,vitesse,
                  &InBuffSz,&OutBuffSz);
          engorge_err = 0;
          pari_err = 0;
          stop_err = 0;
          brkint = 0;
          }
        break;
        }
      case 0x14D:
        {
        if (voie=='4') voie='1';
          else voie++;
        printf("%c",voie);
        delay(200);
        gotoxy(10,2);
        if (!ComExist[voie-0x31]) resul=1; else resul=0;
        if (resul!=0)
          {
          if (voie=='1') voie='4';
            else voie--;
          printf("%c%c",voie,0x07);
          gotoxy(10,2);
          }
        else
          {
          erreur = Close_Port();
          CommPort = voie-0x31;
          erreur = Open_Port();
          Voie_active = voie;
          IOStream_WRITE(0,0,0);  /* Assure l'orientation du DEVICE...     */
          IOStream_WRITE(0,0,0);  /* Assure reset des contrles de flux... */
          resul = Init_Port(longueur,stop_bit,parity,vitesse,
                  &InBuffSz,&OutBuffSz);
          engorge_err = 0;
          pari_err = 0;
          stop_err = 0;
          brkint = 0;
          }
        break;
        }
      case 0x14B:
        {
        if (voie=='1') voie='4';
          else voie--;
        printf("%c",voie);
        delay(200);
        gotoxy(10,2);
        if (!ComExist[voie-0x31]) resul=1; else resul=0;
        if (resul!=0)
          {
          if (voie=='4') voie='1';
            else voie++;
          printf("%c%c",voie,0x07);
          gotoxy(10,2);
          }
        else
          {
          erreur = Close_Port();
          CommPort = voie-0x31;
          erreur = Open_Port();
          Voie_active = voie;
          IOStream_WRITE(0,0,0);  /* Assure l'orientation du DEVICE...     */
          IOStream_WRITE(0,0,0);  /* Assure reset des contrles de flux... */
          resul = Init_Port(longueur,stop_bit,parity,vitesse,
                  &InBuffSz,&OutBuffSz);
          engorge_err = 0;
          pari_err = 0;
          stop_err = 0;
          brkint = 0;
          }
        }
      }
    }
  }


vitesse_setup()
  {
  long vitesse0;

  choix = 0;
  vitesse0 = vitesse;
  /* Sous-menu du bas de page. */
  textbackground(LIGHTGRAY);
  textcolor(BLACK);
  gotoxy(1,25);
  cputs(" Slection de la vitesse de transmission:              puis                  ");
  textcolor(RED);
  gotoxy(44,25); cputs("  ou  ");
  gotoxy(46,25); printf("%c",16);
  gotoxy(51,25); printf("%c",17);
  gotoxy(61,25); cputs("Retour chariot");
  textcolor(BLACK);
  gotoxy(27,2);
  /* Choix */
  while ( (choix!=0x0D) & (!abandon) )
    {
    while ( (choix=get_clav()) == 0 );
    if (choix==0x14D)
      {
      switch (vitesse)
        {
        case  110: vitesse = 150;
                   cputs("   150  ");
                   break;
        case  150: vitesse = 300;
                   cputs("   300  ");
                   break;
        case  300: vitesse = 600;
                   cputs("   600  ");
                   break;
        case  600: vitesse = 1200;
                   cputs("  1200  ");
                   break;
        case 1200: vitesse = 2400;
                   cputs("  2400  ");
                   break;
        case 2400: vitesse = 4800;
                   cputs("  4800  ");
                   break;
        case 4800: vitesse = 9600;
                   cputs("  9600  ");
                   break;
        case 9600: vitesse = 19200;
                   cputs("  19200 ");
                   break;
        case 19200: vitesse = 28800;
                   cputs("  28800 ");
                   break;
        case 28800: vitesse = 38400;
                   cputs("  38400 ");
                   break;
        case 38400: vitesse = 57600;
                   cputs("  57600 ");
                   break;
        case 57600: vitesse = 115200;
                   cputs(" 115200 ");
                   break;
        case 115200: vitesse = 110;
                   cputs("   110  ");
        }
      gotoxy(27,2);
      }
    if (choix==0x14B)
      {
      switch (vitesse)
        {
        case  110: vitesse = 115200;
                   cputs(" 115200 ");
                   break;
        case  150: vitesse = 110;
                   cputs("   110  ");
                   break;
        case  300: vitesse = 150;
                   cputs("   150  ");
                   break;
        case  600: vitesse = 300;
                   cputs("   300  ");
                   break;
        case 1200: vitesse = 600;
                   cputs("   600  ");
                   break;
        case 2400: vitesse = 1200;
                   cputs("  1200  ");
                   break;
        case 4800: vitesse = 2400;
                   cputs("  2400  ");
                   break;
        case 9600: vitesse = 4800;
                   cputs("  4800  ");
                   break;
        case 19200: vitesse = 9600;
                   cputs("  9600  ");
                   break;
        case 28800: vitesse = 19200;
                   cputs("  19200 ");
                   break;
        case 38400: vitesse = 28800;
                   cputs("  28800 ");
                   break;
        case 57600: vitesse = 38400;
                   cputs("  38400 ");
                   break;
        case 115200: vitesse = 57600;
                   cputs("  57600 ");
        }
      gotoxy(27,2);
      }
    }
  /* Indication de la nouvelle vitesse au pilote. */
  resul = Init_Port(longueur,stop_bit,parity,vitesse,&InBuffSz,&OutBuffSz);
  /* Si nouvelle init. refuse, retour  la valeur prcdente. */
  if (resul!=0)
    {
    vitesse = vitesse0;
    gotoxy(27,2);
    cputs("  9600 ");
    Init_Port(longueur,stop_bit,parity,vitesse,&InBuffSz,&OutBuffSz);
    }
  }


structure_octet()
  {
  int  xpos;
  char element;  /* parit, nboctets ou stop-bit. */

  element = PARITE;
  choix = 0;
  xpos = 57;
  /* Sous-menu du bas de page */
  textbackground(LIGHTGRAY);
  textcolor(BLACK);
  gotoxy(1,25);
  cputs(" Slection de la structure des octets mis:              puis                ");
  textcolor(RED);
  gotoxy(45,25); cputs("Espace/ | ");
  gotoxy(53,25); printf("%c",16);
  gotoxy(55,25); printf("%c",17);
  gotoxy(63,25); cputs("Retour chariot");
  textcolor(BLACK);
  gotoxy(xpos,2);
  /* Choix */
  while ( (choix!=0x0D) & (!abandon) )
    {
    while ( (choix=get_clav()) == 0 );
    switch (choix)
      {
      case 0x14D: switch (element)  /* Flche droite */
                  {
                  case PARITE:
                    switch (parity)
                      {
                      case 'N': parity = 'P';
                                cputs("P");
                                break;
                      case 'P': parity = 'I';
                                cputs("I");
                                break;
                      case 'I': parity = 'T';
                                cputs("T");
                                break;
                      case 'T': parity = 'R';
                                cputs("R");
                                break;
                      case 'R': parity = 'N';
                                cputs("N");
                      }
                    break;
                  case NBOCTETS:
                    switch (longueur)
                      {
                      case '5': longueur = '6';
                                cputs("6");
                                break;
                      case '6': longueur = '7';
                                cputs("7");
                                break;
                      case '7': longueur = '8';
                                cputs("8");
                                break;
                      case '8': longueur = '5';
                                cputs("5");
                      }
                    break;
                  case STOPBIT:
                    switch (stop_bit)
                      {
                      case '2': stop_bit = '1';
                                cputs("1");
                                break;
                      case '1': stop_bit = '2';
                                cputs("2");
                      }
                  }
                break;
      case 0x14B: switch (element)  /* Flche gauche */
                  {
                  case PARITE:
                    switch (parity)
                      {
                      case 'N': parity = 'R';
                                cputs("R");
                                break;
                      case 'P': parity = 'N';
                                cputs("N");
                                break;
                      case 'I': parity = 'P';
                                cputs("P");
                                break;
                      case 'T': parity = 'I';
                                cputs("I");
                                break;
                      case 'R': parity = 'T';
                                cputs("T");
                      }
                    break;
                  case NBOCTETS:
                    switch (longueur)
                      {
                      case '5': longueur = '8';
                                cputs("8");
                                break;
                      case '6': longueur = '5';
                                cputs("5");
                                break;
                      case '7': longueur = '6';
                                cputs("6");
                                break;
                      case '8': longueur = '7';
                                cputs("7");
                      }
                    break;
                  case STOPBIT:
                    switch (stop_bit)
                      {
                      case '2': stop_bit = '1';
                                cputs("1");
                                break;
                      case '1': stop_bit = '2';
                                cputs("2");
                      }
                  }
                break;
      case ' ': /* Caractristique suivante... */
                element++;
                if (element>STOPBIT) element=PARITE;
      }
    switch (element)
      {
      case PARITE:
         xpos = 57;
         break;
      case NBOCTETS:
         xpos = 61;
         break;
       case STOPBIT:
         xpos = 70;
      }
    gotoxy(xpos,2);
    }
  /* Indication de la nouvelle structure au pilote. */
  resul = Init_Port(longueur,stop_bit,parity,vitesse,&InBuffSz,&OutBuffSz);
  /* Si nouvelle init. refuse, retour  la valeur prcdente. */
  if (resul!=0)
    {
    parity = 'N';
    longueur = '8';
    stop_bit = '1';
    Init_Port(longueur,stop_bit,parity,vitesse,&InBuffSz,&OutBuffSz);
    gotoxy(57,2); cputs("N");
    gotoxy(61,2); cputs("8");
    gotoxy(70,2); cputs("1");
    }
  }


void set_up()
  {
  int x,y;

  choix = 0;
  /* Sous-menu du bas de page. */
  x=wherex(); y=wherey();
  window(1,1,80,25);
  set_up_menu();
  /* Enregistrement des choix. */
  while ( (choix!=0x1B) & (!abandon) )
    {
    while ( (choix=get_clav()) == 0 );
    switch(choix)
      {
      case 0x13B: /* CopyRight et Aide: F1 */
             informations(1);
             window(1,1,80,25);
             break;
      case 0x13C: /* Informations: F2 */
             informations(2);
             window(1,1,80,25);
             break;
      case 0x50: /* Port srie */
      case 0x70:
             Port_serie();
             break;
      case 0x56: /* Vitesse */
      case 0x76:
             vitesse_setup();
             break;
      case 0x53: /* Structure */
      case 0x73:
             structure_octet();
      }
    set_up_menu();
    }
  /* Restitution de l'tat initial de l'cran. */
  main_menu();
  textbackground(BLUE);
  if (! terminal)
    {
    if (y<14) window(1,4,80,13);
      else window(1,15,80,24);
    }
  else window(1,3,80,24);
  gotoxy(x,y);
  }


void ModemCmde()
  {
  char StringCmde[MAXStrLen];
  char CarriageRtn[2];

  textcolor(WHITE);
  if (wherex()!=1) scroll_down();
  cputs("Commande pour le modem: ");
  strcpy(StringCmde,"AT");
  Lit_chaine(StringCmde,wherex(),wherey(),StrLen);
  if ( (StringCmde!="") & (!Saisie_Escape) & (!abandon) )
    {
    CarriageRtn[0] = cr;
    CarriageRtn[1] = EOS;
    strcat(StringCmde,CarriageRtn);
    if (WriteCmde(StringCmde,strlen(StringCmde),TRUE) != 0)
      {
      cputs("Erreur durant l'mission de cette commande.");
      scroll_down();
      }
    }
  }


void traitement_affichage(char caractere)
  {
  char car[1];

  car[0] = caractere;
  car[1] = 0;
  switch (caractere)
    {
    case 0x03: break;
    case 0x0C: {
               if (! terminal) window(1,15,80,24);
               clrscr();
               if (! terminal) window(1,4,80,13);
               break;
               }
    case 0x0A: if (LF_Used) scroll_down();
               break;
    case 0x0D: if (CR_Used) scroll_down();
               break;
    case 0x08: {
               cputs(car);
               cputs(" ");
               cputs(car);
               break;
               }
    case 0x09: cputs("     ");
               break;
    default:   cputs(car);
    }
  }


void traitement_clavier()
  {
  int  code;
  char fox[1] = " ";
  char fox_message[78] =
"Le rapide renard marron a saut 0123456789 fois par dessus le dos de LASSIE !";

  code = get_clav();
  switch (code)
    {
    case 0x110: /* Quitter */
                {
                fin = TRUE;
                break;
                }
    case 0x13B: /* CopyRight et Aide: F1 */
                {
                informations(1);
                break;
                }
    case 0x13C: /* Informations: F2 */
                {
                informations(2);
                break;
                }
    case 0x13D: /* Envoit d'une commande au modem: F3 */
                {
                ModemCmde();
                break;
                }
    case 0x119: /* Paramtres */
                {
                set_up();
                break;
                }
    case 0x121: /* Fox message */
                {
                textcolor(YELLOW);
                fox[1] = 0;
                IO_err = FALSE;
                erreur = WriteCOMM(&cr,1);
                if ( (erreur==0) & (!IO_err) & echo ) scroll_down();
                n_car=0;
                while ( (erreur==0) & (!IO_err) & (n_car<77) )
                  {
                  if (Lent) delay(T_Delay);
                  erreur = WriteCOMM(&fox_message[n_car],1);
                  if ( (erreur==0) & (!IO_err) & echo )
                    {
                    fox[0] = fox_message[n_car];
                    cputs(fox);
                    }
                  n_car++;
                  }
                break;
                }
    case 0x12E: /* Effacement de l'cran "Emission" local */
                /* et de l'cran "Rception" distant      */
                {
                textcolor(YELLOW);
                IO_err = FALSE;
                erreur = WriteCOMM(&clrscreen,1);
                if ( (!IO_err) & (erreur==0) ) clrscr();
                break;
                }
    default: /* Caractre saisi  traiter: mission et affichage */
             {
             IO_err = FALSE;
             erreur = WriteCOMM(&(char)code,1);
             if ( (!IO_err) & (erreur==0) & echo )
               {
               textcolor(YELLOW);
               traitement_affichage((char)code);
               }
             }
    }
  }


/* ===== MODULE PRINCIPAL DU PROGRAMME ===== */

main(int argc, char *argv[])
  {
  byte i,j,k              ;
  char NomPeriph[9]       ;
  char argument[127]      ;
  char beep_error = FALSE ;
  int  *hold_1b           ;
  char carac_recu         ;
  char deb_message[45] = "Votre interlocuteur vient de se CONNECTER ...";
  int OldXpos,OldYpos     ;
  static int Xpos = 1     ;
  static int Ypos = 1     ;
  byte *SendOK = 0        ;
  byte *NbXoff = 0        ;

  /* Ouverture du port logique et vrification */
  /* d'existence de port(s) physique(s)...     */
  erreur = Check_STARCOMM_Present();
  switch (erreur)
    {
    case 0:
    case 1:
      {
      /* Arrt du programme sur erreur 200 si STARCOMM non en DEVICE DRIVER. */
      erreur = 200;
      break;
      }
    case 2:
      {
      Version(ver);
      /* Reprage et fermeture des ports srie physiques accessibles. */
      j=0;
      for (i=0;i<4;i++)
        {
        CommPort=i;
        Port_Opened();
        if (ComExist[CommPort])
          {
          ResetCOM_and_TimMAX(RdTimMAX[0],&OldRdTimMAX,
            WrTimMAX[0],&OldWrTimMAX);
          j++;
          Close_Port();
          }
        }
      /* Arrt du programme sur erreur 300 si aucun port physique trouv ! */
      if (j==0)
        erreur = 300;
      else
        {
        /* Sinon: ouverture du port logique sur une voie existante. */
        CommPort = 0;
        while (!ComExist[CommPort]) CommPort++;
        voie = CommPort+0x31;
        ResetPortDevice();
        erreur = Open_COMM();
        }
      }
    }

  /* Traitement: terminal ou message d'erreur selon possibilits ! */
  if (erreur==0)
    {
    OldIBreak = getvect(Int1B);
    setvect(Int1B,CtrlBreak);
    OldIError = getvect(Int24);
    setvect(Int24,IError);
    /* Recherche spcif. du format de comm.: "COMi:vitesse,par,bits,stop" */
    for(i=1;i<argc;i++)
      {
      strcpy(argument,strupr(argv[i]));
      for (j=0;j<=strlen(argument) & argument[j]!=':' & argument[j]!=',';j++)
        commande[j] = argument[j];
      if (argument[j]==':')
        {
        commande[j] = argument[j];
        j++;
        }
      commande[j] = EOS;
      stock_commande_format();
      while (j<strlen(argument) & argument[j]!='/')
        {
        k=0;
        for (j=j;j<=strlen(argument) & argument[j]!=',' & argument[j]!='/';j++)
          {
          commande[k] = argument[j];
          k++;
          }
        if (argument[j]==',') j++;
        commande[k] = EOS;
        stock_commande_format();
        }
      }
    /* Relvement des options ventuelles depuis la ligne de commandes... */
    for (i=1;i<argc;i++)
      {
      strcpy(argument,strupr(argv[i]));
      j = 0;
      while (j<=strlen(argument))
        {
        for (j=j;j<=strlen(argument) & argument[j]!='/';j++);
        if (argument[j]=='/')
          {
          j++;
          if (argument[j]=='/') j++;
          k = 0;
          while(j<=strlen(argument) & argument[j]!='/' & argument[j]!=' ')
            {
            commande[k] = argument[j];
            k++;
            j++;
            }
          j--;
          commande[k] = EOS;
          if (strcmp(strupr(commande),"TERMINAL")==0) terminal = TRUE;
          if (strcmp(strupr(commande),"T")==0) terminal = TRUE;
          if (strcmp(strupr(commande),"ALARME")==0) beep_error = TRUE;
          if (strcmp(strupr(commande),"A")==0) beep_error = TRUE;
          if (strcmp(strupr(commande),"RALENTI")==0) Lent = TRUE;
          if (strcmp(strupr(commande),"R")==0) Lent = TRUE;
          }
        }
      }
    /* Activation du premier port srie dispo. trouv si celui spcifi */
    /* est dsign comme inexistant, et initialisation de ce port.      */
    Close_Port();
    if (!ComExist[voie-0x31])
      {
      CommPort = 0;
      while (!ComExist[CommPort]) CommPort++;
      voie = CommPort+0x31;
      }
    else CommPort=voie-0x31;
    erreur = Open_Port();
    Voie_active = voie;
    IOStream_WRITE(0,0,0);  /* Assure l'orientation du DEVICE sur CommPort...*/
    resul = Init_Port(longueur,stop_bit,parity,vitesse,&InBuffSz,&OutBuffSz);
    HandShake_Setup(RTS_CTS,FALSE);
    HandShake_Setup(DTR_DSR,FALSE);
    XonoffShaking_Setup(FALSE);
    setup_ecran_inprog();
    page_de_fond();
    /* Message indicateur de connexion tablie vers l'ordinateur distant. */
    IO_err = FALSE;
    erreur = WriteCOMM(&cr,1);
    n_car=0;
    while ( (IO_err==FALSE) & (erreur==0) & (n_car<45) )
      {
      if (Lent) delay(T_Delay);
      erreur = WriteCOMM(&deb_message[n_car],1);
      n_car++;
      }
    if ( (IO_err==FALSE) & (erreur==0) ) erreur = WriteCOMM(&cr,1);
    if ( (IO_err==FALSE) & (erreur==0) ) erreur = WriteCOMM(&cr,1);
    /* Message d'information. */
    informations(1);
    /* Bouclage permanent: attente rception/saisie clavier-mission. */
    while ( (!fin) & (!abandon) )
      {
      if (CheckCOMMIn())
        {
        IO_err = FALSE;
        ReadCOMM(&carac_recu,1);
        if (carac_recu==0x1A) /* EOF => Reset du DOS en accs aux fichiers! */
          {
          if (!terminal)
            {
            OldXpos = wherex();
            OldYpos = wherey();
            window(1,15,80,24);
            gotoxy(Xpos,Ypos);
            }
          textcolor(GREEN);
          erreur = Close_COMM();
          erreur = Open_COMM();
          IO_err = TRUE;
          textcolor(LIGHTGRAY);
          scroll_down();
          cputs("EOF reu: dconnexion probable de votre interlocuteur !");
          scroll_down();
          if (!terminal)
            {
            Xpos = wherex();
            Ypos = wherey();
            window(1,4,80,13);
            gotoxy(OldXpos,OldYpos);
            }
          }
        if (IO_err==FALSE)
          {
          if (!terminal)
            {
            OldXpos = wherex();
            OldYpos = wherey();
            window(1,15,80,24);
            gotoxy(Xpos,Ypos);
            }
          textcolor(GREEN);
          traitement_affichage(carac_recu);
          if (!terminal)
            {
            Xpos = wherex();
            Ypos = wherey();
            window(1,4,80,13);
            gotoxy(OldXpos,OldYpos);
            }
          }
        }
      if (beep_error==TRUE)
        {
        if (Errors_Report())
          {
          engorge_err = engorge_err + Engorgement;
          pari_err = pari_err + Parite;
          stop_err = stop_err + Stop_bit;
          brkint = brkint + Break_it;
          sound(100);
          delay(50);
          nosound();
          }
        }
      while (kb_hit()) traitement_clavier();
      if (XonoffShaking_Status(SendOK,NbXoff)!=Inactif)
        {
        if ( (!SendOK) & (*NbXoff>50) ) XonoffShaking_Setup(Bilateral);
        }
      }
    /* Prparation de l'arrt du programme: il FAUT fermer le port      */
    /* logique AVANT le port physique si l'on veut permettre l'mission */
    /* du code EOF sur la ligne, et viter (en mme temps) une erreur   */
    /* d'criture gnre par la fermeture du fichier logique !         */
    window(1,1,80,25);
    textcolor(LIGHTGRAY);
    textbackground(BLACK);
    setup_ecran_outprog();
    printf(">TERMINAL [<Format de comm>][<options>]\n");
    printf("  <Format de comm>=COMi:vit,par,bit,stp\n");
    printf("  /T = Terminal: cran mono-bloc.\n");
    printf("  /A = <A>larme si erreur en rception.\n");
    printf("  /R = <R>alentir les missions.\n");
    printf("      (lien site lent/rapide: le site\n");
    printf("      lent affiche un nombre croissant\n");
    printf("      d'erreurs d'engorgement).\n\n");
    erreur = Close_COMM();
    i=0;
    while ( (i<8) & (NomDevice[i]!=' ') )
      {
      NomPeriph[i] = NomDevice[i];
      i++;
      }
    NomPeriph[i] = 0;
    setvect(Int1B,OldIBreak);
    setvect(Int24,OldIError);
    if (!erreur)
      {
      if (Attend_Buff_ems_vide(10)!=0)
        printf("Buffer d'mission NON vide !\n");
      erreur = Close_Port();
      printf("Programme termin ");
      if (abandon) printf("sur Ctrl-Break.");
        else
          if (!erreur) printf("normalement.");
            else printf("(port ouvert !)");
      printf(".\nFichier %s: ferm.\n",NomPeriph);
      }
    else printf("Erreur--> Fichier %s: non ferm...\n",NomPeriph);
    }
  else
    {
    switch(erreur)
      {
      case 200:
        {
        printf("STARCOMM.EXE non trouv en DEVICE !\n");
        printf("Placez:       DEVICE = STARCOMM.EXE\n");
        printf("dans votre CONFIG.SYS,et re-bootez.\n");
        break;
        }
      case 300:
        {
        printf("Erreur--> AUCUN PORT SERIE !\n");
        printf("TERMINAL interrompu.\n");
        break;
        }
      default: printf("Erreur DOS n%i !\n",erreur);
      }
    }
  }
